/*
 * Copyright 2011 livedoor Co.,Ltd.
 *
 * Licensed under the Apache License, Version 2.0.
 *
 */

#import "AppDelegate.h"
#import "RootViewController.h"
#import "AuthViewController.h"

@implementation AppDelegate

@synthesize window;
@synthesize navigationController;
@synthesize authViewController;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    self.window.rootViewController = self.navigationController;
    [self.window makeKeyAndVisible];
    
    if (![[NSUserDefaults standardUserDefaults] stringForKey:@"loctouch_access_token"]) {
        [self showAuthViewController];
    }
    
    return YES;
}

- (void)showAuthViewController {
    AuthViewController* controller = [[AuthViewController alloc] initWithNibName:@"AuthViewController" bundle:nil];
    self.authViewController = controller;
    [self.navigationController presentModalViewController:self.authViewController animated:YES];
    
    [controller release];    
}

- (void)dealloc
{
    [window release];
    [navigationController release];
    [authViewController release];
    [super dealloc];
}

- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL*)url {
    
    if ([url.scheme isEqualToString:[self urlScheme]]) {
        
        if ([url.host isEqualToString:@"auth"]) {
            
            if ([url fragment] == nil) {
                NSLog(@"invalid auth callback");
                return NO;
            } else {
                [self.authViewController saveAccessToken:url];
                return YES;                
            }
        }
    }
    return NO;
}

- (NSString*)urlScheme {
    
    NSString *scheme = [[[[[NSBundle mainBundle] objectForInfoDictionaryKey:@"CFBundleURLTypes"] objectAtIndex:0] objectForKey:@"CFBundleURLSchemes"] objectAtIndex:0];
    return scheme;
}

@end
